<template>
  <div class="modal show" @click="beforeClose">
    <div class="modal-dialog modal-dialog-centered modal-xl">
      <div class="modal-content">
        <div class="modal-body" @click.stop="() => {}">
          <div class="close-button-container">
            <button type="button" class="close close-button" aria-label="Close" @click="beforeClose">
              <i class="fas fa-times close-icon"></i>
            </button>
          </div>
          <dimensions-details
            :dimensionsType="dimensionsType"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import DimensionsDetails from './DimensionsDetails.vue'
import dimensionsAttributes from './utils/dimensions-attributes'

export default {

  name: 'DimensionsDetailsModal',
  components: {
    DimensionsDetails
  },
  props: {
    dimensionsType: {
      type: String,
      required: true,
      default () {
        return 'dimensions-details'
      }
    }
  },
  beforeRouteEnter (to, from, next) {
    // called before the route that renders this component is confirmed.
    // does NOT have access to `this` component instance,
    // because it has not been created yet when this guard is called!
    const toDimension = to.params.dimension
    if (!toDimension || !dimensionsAttributes[toDimension]) {
      // Don't confirm navigation when the dimension parameter is non-existant or falsy
      next(false)
    } else {
      // Show modal window the dimension details as content
      document.body.classList.add("modal-open");
      next(true)
      // next(vm => vm.$modal.show('dimensions-details-modal'))
    }
  },
  methods: {
    beforeClose () {
      document.body.classList.remove("modal-open");
      this.$router.push({
        name: (this.dimensionsType === 'dimensions-details' ? 'Dashboard' : 'CatalogueDetailDashboard'),
        query: { locale: this.$i18n.locale }
      });
    }
  }
}
</script>

<style lang="scss" scoped>

.close-button-container {
  position: absolute;
  top: 15px;
  right: 15px;
  z-index: 1000;
  .close-icon {
    font-size: 2rem;
  }
}

.modal {
  background: rgba(0,0,0,0.5);
  display: block;
}

@media only screen and (max-width: 1199.9px) {
  .modal-dialog {
    max-width: none !important;
    width: 100%
  }
}

.modal-body {
  padding: 0;
}

</style>
